/****************************************************************************
  FILE: Event.h
  PURPOSE: Tango API
 ***************************************************************************/


#ifndef __H_EVENT__
#define __H_EVENT__

#if defined( _WIN32 )
#include <winsock2.h>

#if defined( DLL_BUILDING )
#define DLL_EXPORT __declspec( dllexport )
#else
#define DLL_EXPORT __declspec( dllimport )
#endif
#else
typedef int SOCKET;
typedef int HRESULT;
#define DLL_EXPORT
#endif

#define CONTROL 30
#define DATA    31
#define PING    51


struct Event
{
    int type;
    int len;
    char *data;
};

#ifdef __cplusplus
extern "C" {
#endif

DLL_EXPORT SOCKET registerApp(int argc,char *argv[] );
#if defined( _WIN32 )
DLL_EXPORT SOCKET registerWinApp(LPSTR lpCmdLine);
#endif
DLL_EXPORT HRESULT sendEvent(SOCKET sockfd,struct Event *pev );
DLL_EXPORT struct Event* receiveEvent(SOCKET sockfd);
DLL_EXPORT struct Event* createEvent(int type,int len,char *data);
DLL_EXPORT int getType(struct Event *pev);
DLL_EXPORT int getLen(struct Event *pev);
DLL_EXPORT char* getData(struct Event *pev);
DLL_EXPORT void destroyEvent(struct Event *pev);

#ifdef __cplusplus
}
#endif


#endif /*__H_EVENT__*/


