/***************************************************************************
  FILE: TDataListener.java, TomaszMajor-10Apr98
  PURPOSE: interface-to-app
  $Id: TDataListener.java,v 1.7 1999/03/30 04:37:18 toma Exp $
  Component: Plugin, Interfaces
***************************************************************************/


package webwisdom.tango;


/**Interface for passing private application data.
 *@see TAgent#addTDataListener*/
public interface TDataListener
{


    /**This function is called everytime the data is sent
       by any member of the session and this participant
       is either an explicit addresee
       in <tt>selectiveSend()</tt> function,
       or an implicit one in <tt>send()</tt> function.
       The data arrives unchanged and in the same chunks as it was sent.
       *@param data the data sent by another member of the same session
       *@see TAgent#send
       *@see TAgent#selectiveSend*/
    public void receive(byte data[]);


}// TDataListener //////////////////////////////////////////////////////////

