// $Id: MasterChangeEvent.java,v 1.1 1998/09/22 18:33:57 beca Exp $
/*
File: MasterChangeEvent.java
Component: Plugin
Date            Author        Changes
Aug 05 98       Lukasz Beca   Created
*/

package webwisdom.tango.beans;

import java.util.EventObject;

/*
Event used to notify about changes in Tango system state. It is
sent by Tango beans to components that are interested in receiving
such notifications.
*/

public class MasterChangeEvent extends EventObject {

    private String masterName;
    private boolean masterStatus;

    public MasterChangeEvent(Object source, boolean status, String name) {

        super(source);
        masterStatus = status;
        masterName = name;
    }

    public String getMasterName() {
        return masterName;
    }

    public boolean isMaster() {
        return masterStatus;
    }
}
