// $Id: TangoBeanBeanInfo.java,v 1.3 1998/09/22 18:41:24 beca Exp $
/*
File: TangoBeanBeanInfo.java
Component: Plugin
Date            Author        Changes
Aug 05 98       Lukasz Beca   Created
*/
package webwisdom.tango.beans;

import java.beans.*;
import java.awt.event.*;
import java.lang.reflect.Method;
import symantec.itools.beans.*;
import webwisdom.tango.TLAgent;


/*
**    BeanInfo for JavaBean:
*/
public class TangoBeanBeanInfo extends SimpleBeanInfo
{

    // getIcon returns an image object which can be used by toolboxes, toolbars
    // to represent this bean. Icon images are in GIF format.
    public java.awt.Image getIcon(int iconKind)
    {
        if (iconKind == BeanInfo.ICON_COLOR_16x16 ||
            iconKind == BeanInfo.ICON_MONO_16x16)
        {
            java.awt.Image img = loadImage("tangobean.gif");
            return img;
        }
        if (iconKind == BeanInfo.ICON_COLOR_32x32 ||
            iconKind == BeanInfo.ICON_MONO_32x32)
        {
            java.awt.Image img = loadImage("tangobean.gif");
            return img;
        }
        return null;
    }    

public BeanDescriptor getBeanDescriptor() {
		
	SymantecBeanDescriptor bd = new SymantecBeanDescriptor(beanClass);
			
	bd.setFolder("Tango Beans");
	bd.setToolbar("Tango Beans");
							
    ConnectionDescriptor StatusDescriptor = new ConnectionDescriptor( );
	StatusDescriptor.setForm(ConnectionDescriptor.OUTPUT);
	StatusDescriptor.setType("boolean");
	StatusDescriptor.setExpr("%name%.isMaster()" );
	StatusDescriptor.setShortDescription("Am I a master?");
	bd.addConnectionDescriptor(StatusDescriptor);
	
	ConnectionDescriptor UserNameDescriptor = new ConnectionDescriptor( );
	UserNameDescriptor.setForm(ConnectionDescriptor.OUTPUT);
	UserNameDescriptor.setType("String");
	UserNameDescriptor.setExpr("%name%.getUserName()" );
	UserNameDescriptor.setShortDescription("Get user name");
	bd.addConnectionDescriptor(UserNameDescriptor);
	
	ConnectionDescriptor MasterNameDescriptor = new ConnectionDescriptor( );
	MasterNameDescriptor.setForm(ConnectionDescriptor.OUTPUT);
	MasterNameDescriptor.setType("String");
	MasterNameDescriptor.setExpr("%name%.getMasterName()" );
	MasterNameDescriptor.setShortDescription("Get master name");
	bd.addConnectionDescriptor(MasterNameDescriptor);
	
//	ConnectionDescriptor HostnameDescriptor = new ConnectionDescriptor( );
//	HostnameDescriptor.setForm(ConnectionDescriptor.OUTPUT);
//	HostnameDescriptor.setType("String");
//	HostnameDescriptor.setExpr("%name%.getHostname()" );
//	HostnameDescriptor.setShortDescription("Get Hostname");
//	bd.addConnectionDescriptor(HostnameDescriptor);
	
	ConnectionDescriptor ParticipantsDescriptor = new ConnectionDescriptor( );
	ParticipantsDescriptor.setForm(ConnectionDescriptor.OUTPUT);
	ParticipantsDescriptor.setType("String[]");
	ParticipantsDescriptor.setExpr("%name%.getParticipantNames()" );
	ParticipantsDescriptor.setShortDescription("Get participant names");
	bd.addConnectionDescriptor(ParticipantsDescriptor);
	
//	ConnectionDescriptor ParticipantsSizeDescriptor = new ConnectionDescriptor( );
//	ParticipantsSizeDescriptor.setForm(ConnectionDescriptor.OUTPUT);
//	ParticipantsSizeDescriptor.setType("int");
//	ParticipantsSizeDescriptor.setExpr("%name%.getParticipantsSize()" );
//	ParticipantsSizeDescriptor.setShortDescription("Get Size of Participants Table");
//	bd.addConnectionDescriptor(ParticipantsSizeDescriptor);
	
	/*ConnectionDescriptor ActiveUsersDescriptor = new ConnectionDescriptor( );
	ActiveUsersDescriptor.setForm(ConnectionDescriptor.OUTPUT);
	ActiveUsersDescriptor.setType("String[]");
	ActiveUsersDescriptor.setExpr("%name%.getUserNames()" );
	ActiveUsersDescriptor.setShortDescription("Get active user names");
	bd.addConnectionDescriptor(ActiveUsersDescriptor);
	
	ConnectionDescriptor SessionsDescriptor = new ConnectionDescriptor( );
	ActiveUsersDescriptor.setForm(ConnectionDescriptor.OUTPUT);
	ActiveUsersDescriptor.setType("String[]");
	ActiveUsersDescriptor.setExpr("%name%.getSessionNames()" );
	ActiveUsersDescriptor.setShortDescription("Get session names");
	bd.addConnectionDescriptor(ActiveUsersDescriptor); */
	
	ConnectionDescriptor AudioAvailableDescriptor = new ConnectionDescriptor( );
	AudioAvailableDescriptor.setForm(ConnectionDescriptor.OUTPUT);
	AudioAvailableDescriptor.setType("boolean");
	AudioAvailableDescriptor.setExpr("%name%.isAudioAvailable()" );
	AudioAvailableDescriptor.setShortDescription("Is audio available?");
	bd.addConnectionDescriptor(AudioAvailableDescriptor);
	   
	return (BeanDescriptor) bd;
	}
			
    public EventSetDescriptor[] getEventSetDescriptors() {               
           
         String[] participantMethods = {"participantJoined", "participantLeft"};
                
         try {

            EventSetDescriptor participantEvents = new EventSetDescriptor(beanClass, "participant", 
            participantsListenerClass, participantMethods,
            "addParticipantsChangeListener", "removeParticipantsChangeListener");                       
            participantEvents.setDisplayName("Participant joined/left");                       
            
            EventSetDescriptor masterChanged = new EventSetDescriptor(beanClass, "master", 
            masterListenerClass, "masterChanged");                       
            masterChanged.setDisplayName("Master status changed");      
            
            EventSetDescriptor audioChanged = new EventSetDescriptor(beanClass, "audio", 
            audioListenerClass, "audioChanged");                       
            audioChanged.setDisplayName("Audio status changed");      
            
      /*      EventSetDescriptor sessionsChanged = new EventSetDescriptor(beanClass, "event", 
            sessionsListenerClass, "sessionsChanged");                       
            sessionsChanged.setDisplayName("Sessions changed");      
   */         
            
            EventSetDescriptor rv[] =  {masterChanged, audioChanged, participantEvents};
            return rv;
        }
        catch (IntrospectionException e)
        {

            throw new Error(e.toString());

        }
    }
   
    public MethodDescriptor[] getMethodDescriptors() {
     
        Class parameters[] = new Class[1];         
        parameters[0] = PipeConnectEvent.class;
        Class init_par[] = new Class[1];
        init_par[0] = TLAgent.class;
        
        Class getParameters[] = null;
     
        
        try {
        
            MethodDescriptor pipeConnectMethod = new MethodDescriptor(TangoBean.class.getMethod("pipeReady", parameters));
            pipeConnectMethod.setDisplayName("Connect new pipe");                        
                    
            MethodDescriptor tangoInitMethod = new MethodDescriptor(TangoBean.class.getMethod("tangoInit", init_par));
            tangoInitMethod.setDisplayName("Init Tango - use during initialization");  
            
            MethodDescriptor tangoExitMethod = new MethodDescriptor(TangoBean.class.getMethod("tangoExit", null));
            tangoExitMethod.setDisplayName("Exit Tango - use during termination");  
                    
  //          MethodDescriptor masterStatusMethod = new MethodDescriptor(TangoBean.class.getMethod("getMasterStatus", getParameters));
  //         masterStatusMethod.setDisplayName("Get Master Status");
           
           MethodDescriptor rv[] = 
            {pipeConnectMethod,
             tangoInitMethod,
             tangoExitMethod
   //       masterStatusMethod
            }; 
           return rv;
        } catch(NoSuchMethodException e) {
         
            throw new Error(e.toString());            
        }              
    }


   public PropertyDescriptor[] getPropertyDescriptors() {
	try {
	    
	        PropertyDescriptor masterStatus = new PropertyDescriptor("master", beanClass, "isMaster", null);      
	        masterStatus.setDisplayName("Master/slave status");
            PropertyDescriptor userName = new PropertyDescriptor("userName", beanClass, "getUserName", null);      
            userName.setDisplayName("User name");
            PropertyDescriptor masterName = new PropertyDescriptor("masterName", beanClass, "getMasterName", null);       
            masterName.setDisplayName("Master name");
//            PropertyDescriptor hostname = new PropertyDescriptor("hostname", beanClass, "getHostname", null);       
//            hostname.setDisplayName("Hostname");
            PropertyDescriptor participants = new PropertyDescriptor("participantNames", beanClass, "getParticipantNames", null);     
            participants.setDisplayName("Participants");
            PropertyDescriptor audioStatus = new PropertyDescriptor("audio", beanClass, "isAudioAvailable", null);      
	        audioStatus.setDisplayName("Audio status");
 /*           PropertyDescriptor activeUsers = new PropertyDescriptor("userNames", beanClass, "getUserNames", null);          
            activeUsers.setDisplayName("Active Users");
            PropertyDescriptor localApps = new PropertyDescriptor("sessionNames", beanClass, "getSessionNames", null);          	  
 */           
	    PropertyDescriptor rv[] = 
	    {masterStatus,
	    userName,
	    masterName,
//	    hostname,
	    participants,
	    audioStatus};
//	    activeUsers,
//	    localApps};

	    return rv;
	} catch (Exception ex) {
	    System.err.println("TangoBeanBeanInfo: " + ex);
	    return null;
	}
    }



    private final static Class beanClass = TangoBean.class;
//    private final static Class controlListenerClass = ControlListener.class;
    private final static Class participantsListenerClass = ParticipantsChangeListener.class;
    private final static Class masterListenerClass = MasterChangeListener.class;
    private final static Class audioListenerClass = AudioRequestListener.class; 
  
}

