/***************************************************************************
  FILE: CAConsts.java, TomaszJurga-21Nov96
  PURPOSE: SM-to-interfaces protocol
  $Id: CAConsts.java,v 1.5 1999/04/14 20:16:04 toma Exp $
  Component: Plugin
***************************************************************************/


package webwisdom.tango.consts;


public class CAConsts 
{ 
    // message type - first byte of the table
    public static final byte ISMASTER=1;
    public static final byte USERNAME=2;
    public static final byte MASTERNAME=3;
    public static final byte HOSTNAME=4;
    public static final byte PARTICIPANTS=5;
    public static final byte ACTIVEUSERS=6;
    public static final byte LOCALAPPS=7;  
    public static final byte DATAPASS=8;
    
    // message answer - second byte of the table (only for ISMASTER query)
    public static final byte YES=10;
    public static final byte NO=11;
    
    public static final byte TERMINATE=12;
    public static final byte DEFCON_DATA=50;
    public static final byte AUDIO_OFF=121;
    public static final byte FOCUS=122;
    public static final byte AUDIO_ON=123;
    public static final byte PARTIPUID=125;

    /**messages for BV*/
    public static final byte JOIN=60;
    public static final byte NEW=61;
    public static final byte LEAVE=62;
    public static final byte DELETE=63;

    /**
     *@param t type of CAppRequestEventMessage or CAppAnswerEventMessage
     *@return message type name*/
    public static String toString(byte t)
    {
      switch(t)
      {
	case ISMASTER:
	  return "ISMASTER";
	case USERNAME:
	  return "USERNAME";
	case MASTERNAME:
	  return "MASTERNAME";
	case PARTICIPANTS:
	  return "PARTICIPANTS";
	case TERMINATE:
	  return "TERMINATE";
	case FOCUS:
	  return "FOCUS";
	case PARTIPUID:
	  return "PARTIPUID";
	case JOIN:
	  return "JOIN";
	case NEW:
	  return "NEW";
	case LEAVE:
	  return "LEAVE";
	case DELETE:
	  return "DELETE";
	default:
	  return "UNDEFINED";
      }
    }// toString ___________________________________________________________


}// CAConsts ///////////////////////////////////////////////////////////////

