/***************************************************************************
  FILE: BvListener.java, TomaszMajor-10Apr99
  PURPOSE: interface-to-BV
  $Id: BvListener.java,v 1.1 1999/04/14 20:19:29 toma Exp $
  Component: Plugin, Interfaces
***************************************************************************/


package webwisdom.tango.extras;


/**Interface for system notifications to BuenaVista.
   *@see TAgent#addBvListener*/
public interface BvListener
{


    /**This function is called after registration.
       *@see webwisdom.tango.TAgent#isMaster
       *@see webwisdom.tango.TAgent#getMasterName
       *@see disconnected*/
    public void connected(String masterName,int masterId,int masterIP);


    /**Called when the application is removed from the session.
       *@see connected*/
    public void disconnected();


    /**Called when a Tango user joins this session.
     *@see webwisdom.tango.TAgent#getParticipantNames*/
    public void participantJoined(String userName,int userId,int userIP);


    /**Called when a participant of this session leaves this session.
     *@see webwisdom.tango.TAgent#getParticipantNames*/
    public void participantLeft(String userName,int userId,int userIP);


}// BvListener /////////////////////////////////////////////////////////////

