/***************************************************************************
  FILE: CAppAnswerEventMessage.java, TomaszJurga-10Dec96
  PURPOSE: main interface
  $Id: CAppAnswerEventMessage.java,v 1.6 1999/03/30 04:37:27 toma Exp $
  Component: Plugin
***************************************************************************/


package webwisdom.tango.messages;


import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.consts.*;
import java.util.Vector;
import java.io.*;


public class CAppAnswerEventMessage extends AppEventMessage
{
    private static final String CL="CaAnswer";


    public CAppAnswerEventMessage(byte[] tab)
    {
      super(Const.CONTROL,tab);
    }// CAppAnswerEventMessage _____________________________________________


    private byte getSubType()
    {
      return super.getData()[0];
    }// getSubType _________________________________________________________


    private Vector processData()
    {
      int len = super.getLen();
      byte[] data = super.getData();
      
      int index=1;
      Vector vect = new Vector();
      
      while (index<len)
      {
	int strlen = (int) data[index];
	index++;
	String pom = new String(data,0,index,strlen);
	vect.addElement(pom);
	index+=strlen; 
      }
      
      return vect;
    }// processData ________________________________________________________


    public byte getAnswerType()
    {
      return getSubType();
    }// getAnswerType ______________________________________________________


    public boolean isMaster()
    {
      if(getSubType()!=CAConsts.ISMASTER)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.ISMASTER));


      return super.getData()[1]==CAConsts.YES;
    }// isMaster ___________________________________________________________


    public String getMastername()
    {
      if(getSubType()!=CAConsts.MASTERNAME)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.MASTERNAME));


      return new String(super.getData(),0,1,getLen()-1);
    }// getMastername ______________________________________________________


    public String getUsername()
    {
      if(getSubType()!=CAConsts.USERNAME)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.USERNAME));


      return new String(super.getData(),0,1,getLen()-1);
    }// getUsername ________________________________________________________


    public Vector getParticipants()
    {
      if(getSubType()!=CAConsts.PARTICIPANTS)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.PARTICIPANTS));


      return processData();
    }// getParticipants ____________________________________________________


//********************* obsolete methods *********************


    public byte[] getData()
    {
      //throw new RuntimeException("deprecated method");
      //System.out.println(CL+".getData(): this is a big mess");
      //return super.getData();
      //throw new RuntimeException("deprecated method");
      if(getSubType()==CAConsts.DATAPASS)
      {
	throw new RuntimeException("deprecated method");
// 	ByteArrayOutputStream datapass = new ByteArrayOutputStream();
// 	byte[] data = super.getData();
// 	int len = super.getLen();
// 	int appname_len = data[1];
// 	datapass.write(data,appname_len+2,len-appname_len-2);
// 	return datapass.toByteArray();
      }
      else
      {
	System.out.println(CL+".getData(): this is a bigmess");
	try
	{
	  byte[] tmp = super.getData();
	  byte[] res = new byte[tmp.length-1];
	  System.arraycopy(tmp,1,res,0,tmp.length-1);
	  return res;
	} 
	catch(Exception e)
	{
	  e.printStackTrace();
	  return null;
	}
      }
    }// getData ____________________________________________________________


    public String getSender()
    {
      throw new RuntimeException("deprecated method");
//     if ((super.getData())[0]==CAConsts.DATAPASS)
//     {
//       ByteArrayOutputStream appname = new ByteArrayOutputStream();
//       byte[] data = super.getData();
//       int len = super.getLen();
//       int appname_len = data[1];
//       appname.write(data,2,appname_len);
    
//       return new String(appname.toByteArray(),0);
//     }
//     else return null;
    }// getSender __________________________________________________________

    
    public String getHostname()
    {
      throw new RuntimeException("deprecated method");
//     if ((super.getData())[0]==CAConsts.HOSTNAME)
//     {
//       byte[] data = super.getData();
//       int len = super.getLen();

//       return new String(data,0,1,len-1);
//     }
//     else return null;
    }// getHostname ________________________________________________________

    
    public Vector getActiveUsers()
    {
      throw new RuntimeException("deprecated method");
//     if ((super.getData())[0]==CAConsts.ACTIVEUSERS)
//     {
//       return processData();
//     }
//     else return null;
    }// getActiveUsers _____________________________________________________


    public Vector getLocalApps()
    {
      throw new RuntimeException("deprecated method");
//     if ((super.getData())[0]==CAConsts.LOCALAPPS)
//     {
//       return processData();
//     }
//     else return null;  
    }// getLocalApps _______________________________________________________


//********************* end of obsolete methods *********************


    public String toString()
    {
      return CL+"@"+hashCode()+"["+CAConsts.toString(getSubType())+"]";
    }// toString ___________________________________________________________


}// CAppAnswerEventMessage /////////////////////////////////////////////////


