// $Id: JoinMessage.java,v 1.4 1998/07/10 20:15:28 beca Exp $
/*
File: JoinMessage.java
Component: Server, Plugin
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/


package webwisdom.tango.messages;


import webwisdom.tango.messages.Message;
import webwisdom.tango.consts.Const;
import java.io.*;


/**
 * A class representing message JOIN
 * 
 *@author Lukasz Beca
 *@see Central Server - Local Demon protocol
 **/
public class JoinMessage extends Message
{
    private static final String CL="JoinMessage";

  
    private int AT;
    private int SID;

/**
   * Creates a new JOIN message
   *@param ATparam application type
   *@param SIDparam session number
   **/


  public JoinMessage(int ATparam, int SIDparam) {

   AT = ATparam;
   SID = SIDparam;
   type = Const.JOIN;
  }

  /**
   * Creates a new JOIN message, information is read from the input stream
   *@param instream  input stream
   **/


  JoinMessage(DataInputStream instream) throws IOException {
    

    
    AT = instream.readInt();
    SID = instream.readInt();
   
    type = Const.JOIN;
    
  }


 /**
   * Writes JOIN message to the output stream
   *@param outstream  output stream
   **/


  void send(DataOutputStream outstream) throws IOException {
     
    //System.out.println("Sending type " + Const.JOIN);
    outstream.writeInt(Const.JOIN);
    //System.out.println("Sending AT " + AT);
    outstream.writeInt(AT);
    //System.out.println("Sending SID " + SID);
    outstream.writeInt(SID);
    outstream.flush();

  }
  
 /**
   * Returns application type
   **/


  public int getAT() {
       
    return AT;

  }  

  /**
   * Returns session number
   **/ 

  public int getSID() {
   
    return SID;
  }


    public String toString()
    {
      return CL+"[AT="+AT+",SID="+SID+"]";
    }// toString ___________________________________________________________


}// JoinMessage ////////////////////////////////////////////////////////////


