// $Id: LogaccMessage.java,v 1.4 1998/07/10 20:15:29 beca Exp $
/*
File: LogaccMessage.java
Component: Server, Plugin
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/


package webwisdom.tango.messages;


import webwisdom.tango.messages.Message;
import webwisdom.tango.consts.Const;
import java.io.*;


/**
 * A class representing LOGACC message 
 * 
 *@author Lukasz Beca
 *@see Central Server - Local Demon protocol
 **/
public class LogaccMessage extends Message
{
    private static final String CL="";


    private String username;
    private String privileges;
    private int UID;


 /**
   *Creates a new LOGACC message
   *@param usernameparam username
   *@param UIDparam user number
   *@param prparam privileges of the user
   **/

  public LogaccMessage(String usernameparam, int UIDparam, String prparam) {

   username = new String(usernameparam);
   UID = UIDparam;
   privileges = new String(prparam);
   type = Const.LOGACC;
  }

 /**
   * Creates a new LOGACC message, information is read from the input stream
   *@param instream  input stream
   **/

  LogaccMessage(DataInputStream instream) throws IOException {
    
    
    username = instream.readUTF();
    UID = instream.readInt();
    privileges = instream.readUTF();
    
    type = Const.LOGACC;
    
  }

/**
   * Writes LOGACC message to the output stream
   *@param outstream  output stream
   **/

  void send(DataOutputStream outstream) throws IOException {
  
   
    outstream.writeInt(Const.LOGACC);
    outstream.writeUTF(username);
    outstream.writeInt(UID);
    outstream.writeUTF(privileges);
    outstream.flush();

  }
  
 /**
   * Returns user name
   **/


  public String getUsername() {
    
    String result = new String(username);

    return result;

  }  

 /**
   * Returns user number
   **/
  

  public int getUID() {

    return UID;
  }

 /**
   * Returns user privileges
   **/


  public String getPrivileges() {
    
    String result = new String(privileges);

    return result;
  }	

    public String toString()
    {
      return CL+"["+username+","+privileges+",UID="+UID+"]";
    }// toString __________________________________________________________


}// LogaccMessage /////////////////////////////////////////////////////////

