// $Id: Message.java,v 1.4 1998/07/10 20:15:33 beca Exp $
/*
File: Message.java
Component: Server, Plugin
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/


package webwisdom.tango.messages;


import java.io.*;
import webwisdom.tango.consts.Const;


/**
* Base class for other message classes
*
* @version	1.0 22 Aug 1995
* @author 	Lukasz Beca
*
**/
public abstract class Message
{


    /**type of message
     *@see class Const*/
    protected int type;


    /**Creates undefined message*/
    Message()
    {
      type = Const.UNDEFINED;
    }


    /**
     *@return type of the message represented by this object
     *@see Const*/
    public int getType()
    {
      return type;
    }


    /**Abstract method sending message 
     *@param outstream message is put to outstream stream*/
    abstract void send(DataOutputStream outstream) throws IOException;
    // send _______________________________________________________________


}// Message ///////////////////////////////////////////////////////////////


