// $Id: DemonProtocol.java,v 1.6 1998/11/03 22:17:00 beca Exp $
/*
File: DemonProtocol.java
Component: Plugin
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.protocols;


import webwisdom.tango.threads.DemonThreadIn;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.messages.*;
import java.io.*;
import webwisdom.tango.consts.Const;
import webwisdom.tango.structures.CentralServer;


public class DemonProtocol 
{
    private static final String CL="DemonProtocol";


    protected ThreadOut out;
    protected CentralServer cs;

    private int UID;

    
    public DemonProtocol(ThreadOut outpar,CentralServer cspar)
    {
      out=outpar;
      cs=cspar;
      UID=0;
    }// DemonProtocol ______________________________________________________

  
    public void handleCOMMAND(CommandMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleCOMMAND ______________________________________________________


    public void handleEVENT(EventMessage m)
    {
      //System.out.println(CL+": "+m);
      int AID=m.getAID();
      if(AID==Const.CRLAID) {
	      cs.sendCSToCAB(m);
	//      System.out.println(CL+": "+m.getData());
	
	}
      else
	cs.sendCSToApp(m);
    }// handleEVENT ________________________________________________________


    public void handleRASK(RaskMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleRASK _________________________________________________________


    public void handleSUPD(SupdMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleSUPD _________________________________________________________


    public void handleMASK(MaskMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleMASK _________________________________________________________


    public void handleLOGACC(LogaccMessage m)
    {
      //System.out.println(CL+": "+m);
      UID=m.getUID();
      cs.sendCSToCAB(m);
    }// handleLOGACC _______________________________________________________


    public void handleJASK(JaskMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleJASK _________________________________________________________


    public void handleJANS(JansMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleJANS _________________________________________________________


    public void handleRANS(RansMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleRANS _________________________________________________________

  
    public void handleMANS(MansMessage m)
    {
      //System.out.println(CL+": "+m);
      cs.sendCSToCAB(m);
    }// handleMANS _________________________________________________________
  
  
    public void handlePING(PingMessage m)
    {
      //System.out.println(CL+": "+m);
      out.putMessage(m);
    }// handlePING _________________________________________________________


    public void logout()
    {
      LogoutMessage m=new LogoutMessage(UID);
      out.putMessage(m);
    }// logout _____________________________________________________________


    public void started(int AID,int SID)
    {
      StartedMessage m=new StartedMessage(AID,SID);
      out.putMessage(m);
    }// started ____________________________________________________________


}// DemonProtocol //////////////////////////////////////////////////////////


