// $Id: License.java,v 1.6 1999/03/29 21:50:38 beca Exp $
/*
File: License.java
Component: Server
Date		Author		Changes
Feb 15 99	Lukasz Beca	Created
*/

package webwisdom.tango.server;
 
import java.io.*;
import java.util.*;
import java.security.*;
import webwisdom.tango.test.Log;


public class License {
  
  private MessageDigest md;
  
  private int allowedUsers;
  private GregorianCalendar expirationDate;
  private int type;
  private String tangoLicense;
  private String localIP;
      
  public static final int UNLIMITED = 1;
  public static final int EVALUATION = 2;
  public static final int COMMERCIAL = 3;
  public static final int INVALID = 4;
  public static final int GENERAL = 5;
  public static final int USERLIMIT = 100;
  public static final int DATELIMIT = 13;
  
  
  public License(String license, String ip){

//      passwdFile = new File(filename);
 
	  allowedUsers = -1;
	  expirationDate = null;
	  type = INVALID;
	  tangoLicense = license.trim();
	  localIP = ip;
	  
//	  Log.out.println("tango license" + tangoLicense, 4);
	        
    try { 
       
	    md = MessageDigest.getInstance("SHA");      	       	    
	      
	  } catch(Exception e) {
	    
	    e.printStackTrace();
	    md = null;
	    
	  } 
	  
		interpretLicense();		   	    	           
  }
  
  public final GregorianCalendar getExpirationDate() {
  
    return expirationDate;
  
  }
  
  
  public final int getAllowedUsers() {
  
    return allowedUsers;
  
  }
  
  public final int getLicenseType() {
  
    return type;
  
  }
  
  public final boolean isValid() {
  
    return (!(type == INVALID));
  }
  
  
    
  private void interpretLicense() {
  
     
    if (!isUnlimitedLicense()) {
    
      if (!isEvaluationLicense()) {
      
	      if (!isCommercialLicense()) {
	      
		      if (!isGeneralLicense()) {
		    
			      type = INVALID;
		      }
	      }    
	    }
	  }  
  }
  
  
  private boolean isUnlimitedLicense() {

    boolean result = false;
       String license;
    String tmp1;
    String tmp2;
    
    
    tmp1 = "sldk";
    tmp2 = "4874";
    
    license = tmp1 + tmp2;
    
    tmp1 = "jsxa";        
    tmp2 = "pqwd";
    
    license = license + tmp1 + tmp2;

    tmp2 = "iedn"; 
    tmp1 = "v984";
    
    license = license + tmp1 + tmp2;
    
    tmp1 = "io39";
    tmp2 = "8wdk"; 
    
    license = license + tmp1 + tmp2;
   
    tmp2 = "734k"; 
    tmp1 = "fd89";
    
    license = license + tmp1 + tmp2;
    
    tmp1 = "ub98";
    tmp2 = "34zi";
    
    license = license + tmp1 + tmp2;    
    
    tmp1 = "ha983";
    
    license = license + tmp1;   
    
    String template = getTemplate(license);
    
//    System.out.println("unlimited check: " + template);
    
    
    if (tangoLicense.equals(template)) {
    
      type = UNLIMITED;
      result = true;
    
    }  
    
    return result;
  }
    
  
  private boolean isEvaluationLicense() {
  
    GregorianCalendar now = new GregorianCalendar();
    int month = now.get(GregorianCalendar.MONTH);
    int year = now.get(GregorianCalendar.YEAR);
    int checkMonth = month - 3;
    int usedYear = year;          
    int usedMonth = month - 3;
    int expMonth = 0;
    int expYear = 0;
    String template;
    boolean result = false;    
    String license;
    String tmp1;
    String tmp2;

    
    do {
      
      checkMonth ++;
      
	    if (checkMonth < 0) {
	    
	      usedYear = year - 1;	      	     	      
		    usedMonth = 12 + checkMonth;
		      		   	      	    
	    } else {
	    
	      usedYear = year;
	      usedMonth = checkMonth;
	    
	    }
	    
//	    Log.out.println("eval: " + usedMonth + " " + usedYear, 4);
       
//	    template = getTemplate("eojiads9843" + usedMonth + "84kajfla983" + usedYear + "ekds9488934dtmkj" + localIP + "bds83fq");

      license = "";

      tmp2 = "ads98";

      tmp1 = "eoji";
        
      license = tmp1 + tmp2;
    
      tmp1 = "43";
    
      license = license + tmp1;
    
      license = license + usedMonth;
    
      tmp1 = "84ka";
    
      tmp2 = "jfla";
    
      license = license + tmp1 + tmp2;
    
      tmp1 = "983"; 
    
      license = license + tmp1 + usedYear;
    
      tmp2 = "9488";
  
	    tmp1 = "ekds";
          
      license = license + tmp1 + tmp2;
      
      tmp1 = "934d";
      
      tmp2 = "tmkj";
    
      license = license + tmp1 + tmp2; 
            
      tmp1 = "bds8";
    
      license = license + tmp1 + localIP;    
       
      tmp1 = "3fq";
    
      license = license + tmp1;
      
      template = getTemplate(license);     

//	    System.out.println(template);
	  		  
	  } while (!tangoLicense.equals(template) && checkMonth != month);
	  
		if (tangoLicense.equals(template)) {
    
      type = EVALUATION;
      expMonth = usedMonth + 3;
      expYear = usedYear;
      
      if (expMonth > 11) {
      
	      expMonth = expMonth - 12;
	      expYear ++;
      
      }
      
      expirationDate = new GregorianCalendar(expYear, expMonth, 1);
      
      result = true;
    
    }  
 
    return result;			          
  
  }
  
  
  private boolean isCommercialLicense() {
  
    int connections = 0;
    String template;
    boolean result = false;
    String license;
    String tmp1;
    String tmp2;   
    
    do {
      
      connections ++;
      
      license = "";
    
    
      tmp2 = "ls39";
      tmp1 = "qpmc";
    
      license = tmp1 + tmp2; 
    
      tmp1 = "23ka";
    
      license = license + tmp1 + connections;    
    
      tmp2 = "k98c";    
      tmp1 = "qwle";    
    
      license = license + tmp1 + tmp2;
    
      tmp1 = "nmx";
    
      license = license + tmp1 + localIP;  
          
	    tmp1 = "eiow";
      tmp2 = "knv2";
  
      license = license + tmp1 + tmp2;
      
      template = getTemplate(license);
  
  

//    template = getTemplate("qpmcls3923ka" + connections + "qwlek98cnmx" + localIP + "eiowknv2");
//      System.out.println(license);
		  
	  } while (!tangoLicense.equals(template) && connections < 100);   
    
    if (tangoLicense.equals(template)) {
    
      type = COMMERCIAL;
      allowedUsers = connections;
      result = true;
    
    } 
    
    if (result == false) {
    
      connections = 0;
    
      do {
      
	      connections ++;
	      
	      license = "";
	      tmp2 = "euql";  
	      tmp1 = "34oi";
    
	      license = tmp1 + tmp2;      
	  
		    tmp2 = "b";   
	      tmp1 = "sjsv";
    
	      license = license + tmp1 + tmp2;
    
	      tmp1 = "ewie";
    
	      license = license + connections + tmp1;     
    
	      tmp1 = "natr";
	      tmp2 = "qe98";
    
	      license = license + tmp1 + tmp2;
        
	      tmp1 = "4lla";
	      tmp2 = "d263";
    
	      license = license + tmp1 + tmp2;        
    
	      tmp2 = "cs";
	      tmp1 = "mbxz";
    
	      license = license + tmp1 + tmp2;     
    
	      template = getTemplate(license);
	      
	      
//	      template = getTemplate("34oieuqlsjsvb" + connections + "ewienatrqe984llad263mbxzcs");
//	      Log.out.println(template, 4);
		  
	    } while (!tangoLicense.equals(template) && connections < USERLIMIT);   
    
      if (tangoLicense.equals(template)) {
    
	      type = COMMERCIAL;
	      allowedUsers = connections;
	      result = true;
    
      }             
    }
               
    return result;
  }
  
  private boolean isGeneralLicense() {
  
    GregorianCalendar now = new GregorianCalendar();
    int month = now.get(GregorianCalendar.MONTH);
    int year = now.get(GregorianCalendar.YEAR);
    int checkMonth = 0;
    int usedYear = year;          
    int usedMonth = 0;
    int expMonth = 0;
    int expYear = 0;
    String template;
    boolean result = false;    
    String license;
    String tmp1;
    String tmp2;
    int monthNumber = 0;
    int connections = 0;
    int loop = 0;


    do {
    
      connections ++;
      monthNumber = 0;


    do {
    
      monthNumber ++;
      checkMonth = month - monthNumber;
      usedYear = year;          
      usedMonth = checkMonth;
    
    do {
      
      loop ++;
      System.out.println("loop " + loop + " connections " + connections);
      
      checkMonth ++;
      
	    if (checkMonth < 0) {
	    
	      do {
	    	     	    
		      usedYear = year - 1;	      	     	      
			    usedMonth = 12 + checkMonth;
			    
			  } while(usedMonth < 0);
		      		   	      	    
	    } else {
	    
	      usedYear = year;
	      usedMonth = checkMonth;
	    
	    }
	    
//	    Log.out.println("eval: " + usedMonth + " " + usedYear, 4);
       
//	    template = getTemplate("eojiads9843" + usedMonth + "84kajfla983" + usedYear + "ekds9488934dtmkj" + localIP + "bds83fq");

         tmp2 = "asjl";  
		     tmp1 = "wkcm";
    
	      license = tmp1 + tmp2;      
	  
	      tmp2 = "nwov";   
	      tmp1 = "qmgf";
    
	      license = license + tmp1 + tmp2;
    
	      tmp1 = "rw5i";
    
	      license = license + connections + tmp1;     
    
	      tmp1 = "3mq5";
	      tmp2 = "l8ns";
    
	      license = license + tmp1 + tmp2 + usedMonth;
        
	      tmp1 = "rr3j";
	      tmp2 = "7eia";
    
	      license = license + tmp1 + tmp2 + usedYear;        
    
	      tmp2 = "emvk";
	      tmp1 = "r1mv";
    
	      license = license + tmp1 + tmp2 + monthNumber;
    
	      tmp2 = "m37s";
	      tmp1 = "kw9z";
    
			  license = license + tmp1 + localIP + tmp2;        
	      template = getTemplate(license);     

	    System.out.println(template);
	  		  
	  } while (!tangoLicense.equals(template) && checkMonth != month);
	  
	  
	  } while (!tangoLicense.equals(template) && monthNumber != DATELIMIT);
	  
	  } while (!tangoLicense.equals(template) && connections < USERLIMIT); 
	  
	  
		if (tangoLicense.equals(template)) {
    
      type = GENERAL;
      expMonth = usedMonth + monthNumber;
      expYear = usedYear;
      
      while(expMonth > 11) {
      
	      expMonth = expMonth - 12;
	      expYear ++;
      
      }
            
      expirationDate = new GregorianCalendar(expYear, expMonth, 1);
      allowedUsers = connections;      
      result = true;
    
    }  
 
    return result;			          
  
  }

  
  
  
  private String getTemplate(String content) {
  
    String encPasswd;
    StringBuffer tmpPasswd = new StringBuffer();
    byte[] table;
    int i;
         
    md.update(content.getBytes());                     
    table = md.digest();
     
    for (i = 0; i < table.length - 1; i ++) {
     
       tmpPasswd.append(String.valueOf(table[i]) + ".");     
     
    }
     
    tmpPasswd.append(String.valueOf(table[i]));
               
    encPasswd = tmpPasswd.toString();

    return encPasswd;    
  
  }   
           
}

