// $Id: LicenseManager.java,v 1.3 1999/02/22 23:41:55 beca Exp $
/*
File: LicenseManager.java
Component: Server
Date		Author		Changes
Feb 15 99	Lukasz Beca	Created
*/

package webwisdom.tango.server;
 
import java.io.*;
import java.util.*;
import java.security.*;
import webwisdom.tango.test.Log;
import java.net.*;

public class LicenseManager {

  private static LicenseManager instance = null;
  private License lc;


  public static void init() throws IOException {
  
    instance = new LicenseManager();    
  
  }
  
  public static LicenseManager getInstance() {
    
    return instance;
  }
  
  private LicenseManager() throws IOException {
  
    lc = new License(readLicense(), InetAddress.getLocalHost().getHostAddress());
    
  }    
  
  
  public final GregorianCalendar getExpirationDate() {
  
    return lc.getExpirationDate();
  
  }
    
  public final int getAllowedUsers() {
  
    return lc.getAllowedUsers();
  
  }
  
  public final int getLicenseType() {
  
    return lc.getLicenseType();
  
  }
  
  public final boolean isValid() {
  
    return lc.isValid();
  }
    

  private String readLicense() throws IOException {
  
    String line;
    FileReader licenseFileRead;      
    BufferedReader bufferedFile;
    File licenseFile;
  
//    try { 
       
    licenseFile = new File("license");
    licenseFileRead = new FileReader(licenseFile);      	       	    
	    		      
/*    } catch(FileNotFoundException e) {
	    
	      licenceFile = null;
		    licenceFileRead = null;
	      return null;
	    
	  } catch(Exception e) {
	    
	      licenceFile = null;
	      licenceFileRead = null;
	      e.printStackTrace(Log.err);
	      return null;
	    
	  } */
 
    bufferedFile = new BufferedReader(licenseFileRead);
 
         
    try {
      
        line = bufferedFile.readLine();
	
    } catch(Exception e) {

//       Log.out.println("LicenseManager: " + e, 3);
       line = null;
    }    
             
    return line;

  } 
}



