/****************************************************************************
  $Id: AppletHandle.java,v 1.12 1999/04/07 20:32:26 beca Exp $
****************************************************************************/


package webwisdom.tango.structures;

import webwisdom.tango.structures.Handle;
import webwisdom.tango.interfaces.AppletBaseInterf;
import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.messages.EmptyMessage;
import webwisdom.tango.messages.Message;
import webwisdom.tango.messages.EventMessage;
import webwisdom.tango.consts.Const;
import netscape.javascript.JSObject;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.test.Log;


public abstract class AppletHandle implements Handle, Runnable
{
    private static final String CL="AppletHandle";


    protected AppletBaseInterf app;
    private int AID;
    private LocalApplications lapps;
    private MessageQueue q;
    private boolean exit; 
    private Thread th;
    private int closeMode;
 //   protected JSObject window;

 
    public AppletHandle(AppletBaseInterf a,
			int AIDpar,LocalApplications localpar)
    {
      app = a;
      AID = AIDpar;
      lapps = localpar;
      q = new MessageQueue();
      th = new Thread(this, "AppletHandle:" + hashCode());
      exit = false;
//      window = null; must be initialized correctly by subclass
      closeMode = Const.NONE;
      th.start();
    }// AppletHandle _______________________________________________________


    //interface for LocalApplications
    //public void sendLAToApp(Message m);
    //public synchronized void finish();
    //public synchronized void setFocus();


    public void sendLAToApp(Message m)
    {
      q.putMessage(m);
    }// sendLAToApp ________________________________________________________
  

    public synchronized void finish()
    {
// <<<<<<< AppletHandle.java
//       //Log.out.println(CL+"["+AID+"].finish()");
//       JSObject win=app.getJSWindow();
//       if(win!=null)
// 	win.eval("close();");
// =======
      if(closeMode==Const.NONE)
      {
	Log.out.println("AppletHandle: finishing application:" + AID, 2);
	closeMode = Const.CACLOSED;
	caTermination();
      }
// >>>>>>> 1.7
    }// finish _____________________________________________________________


    public synchronized void setFocus()
    {
      if(Const.inNetscape())
	{
	  netscape.javascript.JSObject win=(netscape.javascript.JSObject) app.getJSWindow();
	  netscape.javascript.JSObject parent=(netscape.javascript.JSObject)win.getMember("top");
	  if(parent==null)
	    {
	      Log.out.println(CL+"setFocus(): unable to get reference to \"top\"!", 2);
	      return;
	    }
	  parent.eval("focus();");
	}
      else
	{
	  java.awt.Frame f=(java.awt.Frame)app.getJSWindow();
	  f.requestFocus();
	  f.toFront();
	}
    }// setFocus ___________________________________________________________
  

    //interface for TLAgent
    //public void sendAppToOther(AppEventMessage m);
    //public void sendAppToOther(AppEventMessage m, int userlist[]);
    //public synchronized void remove();


    public void sendAppToOther(AppEventMessage m)
    {
      lapps.sendAppToOther(AID, m);
    }// sendAppToOther _____________________________________________________
  

    public void sendAppToOther(int userlist[],AppEventMessage m)
    {
      lapps.sendAppToOther(AID,userlist,m);
    }// sendAppToOther _____________________________________________________


    public synchronized void remove()
    {
      //Log.out.println(CL+"["+AID+"].remove()");
      lapps.terminated(AID);
      exit = true;
      q.unblock();    
    }// remove _____________________________________________________________


    //interface for Thread
    //public void run();


    public void run()
    {
      //Log.out.println(CL+"["+AID+"].run()");
      while(!exit)
      {
	Message m=q.getMessage();
	synchronized(this)
	{
	  if(!exit)
	  {
	    AppEventMessage am=(AppEventMessage)m;
	    app.receive(am);
	  }
	}    
      }
      shutdown();
      //Log.out.println("AppletHandle: message queue released");      
    }// run ________________________________________________________________


    //internal methods
    //private void caTermination();
    //private void shutdown();


    protected abstract void caTermination();
    
//    protected abstract void setWindow();
    
/*    protected JSObject getWindow() {
    
      return window;
    } */
    
 

    private void shutdown()
    {
      q.clear();
      q = null;
      app = null;
      lapps = null;
      th = null;
    }// shutdown ___________________________________________________________


    public String toString()
    {
      return CL+"[aid="+AID+"]";
    }// toString ___________________________________________________________


}// AppletHandle ///////////////////////////////////////////////////////////


