// $Id: MessageQueue.java,v 1.5 1998/12/19 22:18:25 beca Exp $
/*
File: MessageQueue.java
Component: Server, Plugin
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.structures;


import java.util.*;
import webwisdom.tango.messages.Message;
import webwisdom.tango.messages.EmptyMessage;
import webwisdom.tango.test.Log;


public class MessageQueue extends Vector
{
    private static final String CL="MessageQueue";


    public MessageQueue()
    {
      super();
    }// MessageQueue _______________________________________________________
  

    public synchronized void putMessage(Message m)
    {
      this.addElement(m);
      notify();
    }// putMessage _________________________________________________________


    public synchronized Message getMessage()
    {
      while(this.isEmpty())
      {
	try
	{
	  wait();
	}
	catch(InterruptedException e)
	{
	  Log.err.println(CL+".getMessage(): wait() interrupted!: "+e, 2);
	  e.printStackTrace(Log.err);
	}
      }
      Message m=(Message)this.firstElement();
      this.removeElementAt(0);	
      return m;
    }// getMessage _________________________________________________________


    public synchronized void unblock()
    {
      EmptyMessage m=new EmptyMessage();
      this.addElement(m);
      notify();
    }// unblock ____________________________________________________________

	
    public synchronized boolean empty()
    {
      return this.isEmpty();
    }// empty ______________________________________________________________


    public synchronized void clear()
    {
      this.removeAllElements();
    }// clear ______________________________________________________________


}// MessageQueue ///////////////////////////////////////////////////////////


