// $Id: Participants.java,v 1.4 1998/12/19 22:18:26 beca Exp $
/*
File: Participants.java
Component: Server
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created

Tested:
OK

*/

package webwisdom.tango.structures;

import java.util.*;
import webwisdom.tango.test.Log;

public class Participants {

  private Vector UIDVector;
  private Vector HostVector;
  private Vector IPVector;

  public Participants() {

     UIDVector = new Vector();
     HostVector = new Vector();
     IPVector = new Vector();
  }

  public synchronized void addParticipant(int UIDpar, String hostpar, String ippar) {
    
    Integer a = new Integer(UIDpar);
    int index;
    
    index = UIDVector.indexOf(a);

    if (index == -1){
      UIDVector.addElement(a);
      HostVector.addElement(hostpar);
      IPVector.addElement(ippar);
    }
    else 
      Log.out.println("Participants: user " + UIDpar + " already logged in from host " + (String) HostVector.elementAt(index) + " , cannot add", 2);
    
  }
    

  public synchronized void deleteParticipant(int UIDpar) {

    Integer UID = new Integer(UIDpar);

    int index;

    index = UIDVector.indexOf(UID);
    if (index != -1) {
    
      UIDVector.removeElementAt(index);
      HostVector.removeElementAt(index);
      IPVector.removeElementAt(index);
    }
	
    else Log.out.println("Participants: user " + UIDpar + " is not logged in, cannot remove", 2);

  }

  public synchronized String getHost(int UIDpar) {

    Integer UID = new Integer(UIDpar);

    int index;
    String result;

    index = UIDVector.indexOf(UID);
    if (index != -1) {

      result = (String) HostVector.elementAt(index);
    }
	
    else {
      Log.out.println("Participants: user " + UIDpar + " is not logged in, cannot get host", 2);
      result = null;
    }

    return result;

  }
  
  public synchronized String getIP(int UIDpar) {
  
     Integer UID = new Integer(UIDpar);

     int index;
     String result;

     index = UIDVector.indexOf(UID);
     if (index != -1) {

       result = (String) IPVector.elementAt(index);
     }
	
     else {
       Log.out.println("Participants: user " + UIDpar + " is not logged in, cannot get ip", 2);
      result = null;
     }

     return result;     	
  
  }
  

  public synchronized Vector getUsers() {
   
   return UIDVector;

  }

  public synchronized boolean isLoggedIn(int UID) {

    Integer tmp = new Integer(UID);
    

    return UIDVector.contains(tmp);
    


  }

  

  

  public void list() {

    int i;
    Integer utmp;
    String htmp;

    Log.out.println("Participants ****************", 2);

    for (i = 0; i < UIDVector.size(); i ++) {

      utmp = (Integer) UIDVector.elementAt(i);
      htmp = (String) HostVector.elementAt(i);

       Log.out.println("User " + utmp + " host " + htmp, 2);
    }

  }
}

