// $Id: UserRegistry.java,v 1.2 1998/12/19 22:18:30 beca Exp $
/*
File: UserRegistry.java
Component: Server
Date		Author		Changes
Oct 26 96	Lukasz Beca	Created

*/
package webwisdom.tango.structures;


import java.lang.*;
import java.util.*;
import java.io.*;
import webwisdom.tango.threads.ThreadIn;
import webwisdom.tango.test.Log;

public class UserRegistry
{
    private static final String CL="UserRegistry";


    private Hashtable users;
    private Vector connected;
    
    public UserRegistry()
    {
     users = new Hashtable();
     connected = new Vector();    }

    public synchronized void connect(ThreadIn tin) {
    
    	connected.addElement(tin);
        Log.out.println(CL + " user added to connected", 2);
    
    }


    public synchronized void addUser(int UID, ThreadIn tin)
    {
      Integer a = new Integer(UID);
      connected.removeElement(tin);
      Log.out.println(CL + " user removed from connected", 2);

      users.put(a, tin);
      Log.out.println(CL + " user added to users", 2);	      
	  	  
    }


   public synchronized void removeUser(int UID, ThreadIn tin) {

    Integer tmp = new Integer(UID);
    Object tableResult;
    boolean vecResult;
    
    tableResult = users.remove(tmp);
    Log.out.println(CL + " user removed from users " + tableResult, 2);
    vecResult = connected.removeElement(tin);   
    Log.out.println(CL + " user removed from connected " + vecResult, 2);
 
   }
   
}// Users //////////////////////////////////////////////////////////////////

