// $Id: Users.java,v 1.9 1999/02/19 22:23:39 beca Exp $
/*
File: Users.java
Component: Server
Date		Author		Changes
Aug 25 96	Lukasz Beca	Created
Oct 07 96       Lukasz Beca     Reading from file added
Tested:
OK

*/
package webwisdom.tango.structures;


import java.lang.*;
import java.util.*;
import java.io.*;
import webwisdom.tango.server.PasswdManager;
import webwisdom.tango.test.Log;

public class Users
{
    private static final String CL="Users";


    private Vector UIDVector;
    private Vector NameVector;
//    private Vector PasswdVector;
    private Vector PrivVector;
    PasswdManager pManager;
    
    // distribution
    private int currentUID;
    private boolean passwordsUsed;


    public Users(boolean passwdMode)
    {
      UIDVector = new Vector();
      NameVector = new Vector();
//      PasswdVector = new Vector();
      PrivVector = new Vector();
      passwordsUsed = passwdMode;                                        
      
      if (passwordsUsed) {
      
	      try {
	  
		      pManager = new PasswdManager("users.txt");
      
	      } catch (Exception e) {
      
			    e.printStackTrace(Log.err);
		      passwordsUsed = false;	
	      }
	      
	    } else {
	    
		    pManager = null;
		
		  }  
      
      currentUID = 1;
      
    }


    public synchronized void addUser(String name,String passwd,String privpar)
    {
      int UID = newUID();
      Integer a = new Integer(UID);
      UIDVector.addElement(a);
      NameVector.addElement(name);
//      PasswdVector.addElement(passwd);
      PrivVector.addElement(privpar);
      Log.out.println(CL+"addUser("+name+"): UID="+UID, 2);
    }


  public synchronized void removeUser(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);
    index = UIDVector.indexOf(tmp);
   
    if (index == -1) {
      Log.err.println(CL+".removeUser("+UID+"): no such user!", 2);
    }
    else {

      UIDVector.removeElementAt(index);
      NameVector.removeElementAt(index);
//      PasswdVector.removeElementAt(index);
      PrivVector.removeElementAt(index);
      Log.out.println(CL+".removeUser("+UID+"): OK", 2);
    }
    
  }
   


/*  public synchronized String getPasswd(String name) {

    int index;
    String result;

    index = NameVector.indexOf(name);
    
    if (index == -1) { 
      System.err.println(CL+".getPasswd(): user " + name + " does not have an account!");
      result = null;
    }
    else
      result = (String) PasswdVector.elementAt(index); 

    return result;

  } */

  public synchronized String getName(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);

    index = UIDVector.indexOf(tmp);
    
    if (index == -1) {
      Log.out.println(CL+".getName(): user " + UID + " does not have an account!", 2);
      result = null;
    }
    else
      result = (String) NameVector.elementAt(index); 

    return result;

  }

   public synchronized String getPriv(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);

    index = UIDVector.indexOf(tmp);
     
    if (index == -1) {
      Log.err.println(CL+".getPriv(): user " + UID + " does not have an account!", 2);
      result = null;
    }
    else
      result = (String) PrivVector.elementAt(index); 

    return result;

  }



  public synchronized int getUID(String name) {
 
    //gets UID of name, if name does not exist in Users then 0 is returned   
  
    int index;
    int result;
    Integer tmp;

    index = NameVector.indexOf(name);
    if (index == -1) {
       Log.err.println(CL+".getUID(): user " + name + " does not have an account!", 2);
      result = -1;
    }
    else {
      tmp = (Integer) UIDVector.elementAt(index);
      result = tmp.intValue();
    }

    return result;
    
  }

    public synchronized boolean passwdUsed() {
    
      return passwordsUsed;
    }


		public synchronized String getStatus(String name) {
		
		  String status;
		  
		
		  if (passwdUsed()) {
	    
	      status = pManager.getStatus(name);	
	      
	    } else {
	    
	      status = null;
	    }
      
      return status;				
		
		}

    public synchronized String getFullName(String name) {
		
		  String fullName;
		  
		
		  if (passwdUsed()) {
	    
	      fullName = pManager.getFullName(name);	
	      
	    } else {
	    
	      fullName = null;
	    }
      
      return fullName;				
		
		}

    public synchronized String getEMail(String name) {
		
		  String eMail;		  
		
		  if (passwdUsed()) {
	    
	      eMail = pManager.getEMail(name);	
	      
	    } else {
	    
	      eMail = null;
	    }
      
      return eMail;				
		
		}



    //checks whether password is ok
    //returns UID if password is valid, otherwise 0
    public synchronized boolean checkPasswd(String name, String passwd)
    {
/*      String p;
      int result;
      p = getPasswd(name);
      if (p != null)
	if (p.equals(passwd) ) 
	  result = getUID(name);
	else
	  result = 0;
      else
	result = 0; */ 
			
	    boolean result;	    	    
	    
	    if (passwdUsed()) {
	    
	      result = pManager.passwordOK(name, passwd);	
	      
	    } else {
	    
	      result = true;
	    }
      
      return result;
    }// checkPasswd ________________________________________________________


    public synchronized int getUsersNumber() {
		
		  return UIDVector.size();
		
		}


    private int newUID()
    {
      int tmp;
      tmp = currentUID;
      currentUID ++;
      return tmp;
    }// newUID _____________________________________________________________


}// Users //////////////////////////////////////////////////////////////////












