// $Id: Log.java,v 1.6 1999/03/30 18:48:31 beca Exp $
/*
File: Log.java
Component: Server, Plugin
Date		Author		Changes
Nov 30 98	Lukasz Beca	Created
*/

package webwisdom.tango.test;


import java.io.*;
import java.util.*;

public class Log extends PrintWriter {

  static public Log out = null;
  static public Log err = null;

  private int level;

  public static void init(String filename, int logLevel) throws IOException {

    FileOutputStream fos=new FileOutputStream(filename);
    out = new Log(fos, logLevel);
    err = out;

  }
  
  public static void init(int logLevel) throws IOException {

     out = new Log(System.out, logLevel);
     err = out;

  }


  private Log(OutputStream os, int logLevel) throws IOException {
  
    super(os, true);
    level = logLevel;

  
  }
      
  public void printSERVER_INIT(String version, String host, String ip, int port, String passwords, 
													       String company, String contact, String expDate, String limit, String status, Date time) {
    
     println("SERVER_INIT1: VERSION=" + version + " HOST=" + host + " IP=" + ip + " PORT=" + port + " STATUS=" + status);
     println("SERVER_INIT2: PASSWORDS=" + passwords + " EXPDATE=" + expDate + " LIMIT=" + limit + " TIME=" + time);
     println("SERVER_INIT3: COMPANY=" + company + " CONTACT=" + contact );
         
  }
          
  public void printUSER_LOGIN(String name, int UID, String userStatus, String host, String ip, String status, Date time) {
  
      println("USER_LOGIN: NAME=" + name + " UID=" + UID + 
										   " USRSTAT=" + userStatus + " HOST=" + host + " IP=" + ip + " STATUS=" + status + " TIME=" + time);             
  }
 
  public void printUSER_LOGOUT(String name, int UID, String status, Date time) {
  
      println("USER_LOGOUT: NAME=" + name + " UID=" + UID + " STATUS=" + status + " TIME=" + time);
 
  }
  
  public void printSESSION_START(String name, int UID, int AT, int SID, String status, Date time) {

      println("SESSION_START: NAME=" + name + " UID=" + UID + " AT=" + AT + " SID=" + SID + " STATUS=" + status + " TIME=" + time);

  }
    
    
  public void printSESSION_TERM(String name, int UID, int AT, int SID, String status, Date time) {
  
     println("SESSION_TERM: NAME=" + name + " UID=" + UID + " AT=" + AT + " SID=" + SID + " STATUS=" + status + " TIME=" + time);
       
  }
  
  public void printSESSION_JOIN(String name, int UID, String master, int MUID, int AT, int SID, int AID, String mode, String status, Date time) {
  
     println("SESSION_JOIN: NAME=" + name + " UID=" + UID + " MASTER=" + master + " MUID=" + MUID + " AT=" + AT + " SID=" + SID + " AID=" + AID + " STATUS=" + status + " TIME=" + time);
     
  }
  
  public void printSESSION_LEAVE(String name, int UID, String master, int MUID, int AT, int SID, int AID, String mode, String status, Date time) {
   
      println("SESSION_LEAVE: NAME=" + name + " UID=" + UID + " MASTER=" + master + " MUID=" + MUID + " AT=" + AT + " SID=" + SID + " AID=" + AID + " STATUS=" + status + " TIME=" + time);    
 
  }

  public void println(String text, int mesgLevel) {
  
      if (mesgLevel <= level) {
	      println(text);
		  }
  
  }
  
  public void print(String text, int mesgLevel) {
  
      if (mesgLevel <= level) {
	      print(text);
		  }
  
  }

  
  
// Log constants

  public static final String OK = "OK";
  public static final String FAILED = "FAILED";
  public static final String LOCAL = "LOCAL";
  public static final String REMOTE = "REMOTE";  
  public static final String NONE = "NONE";
  public static final String CONN_BROKEN = "CONNECTION_BROKEN";
  public static final String FAILED_DENIED = "FAILED_DENIED";
  public static final String FAILED_REMOTEDENIED = "FAILED_REMOTEDENIED";
  public static final String FAILED_PRESENT = "FAILED_PRESENT";
  public static final String TIMEOUT = "TIMEOUT";
  public static final String FAILED_PASSWORD = "FAILED_PASSWORD";
  public static final String FAILED_LICENSE_EXPIRED = "FAILED_LICENSE_EXPIRED";
  public static final String FAILED_LIMIT_EXCEEDED = "FAILED_LIMIT_EXCEEDED";
  public static final String FAILED_INVALID_LICENSE = "FAILED_INVALID_LICENSE";
  public static final String FAILED_NO_LICENSE = "FAILED_NO_LICENSE";
  public static final String FAILED_PORT_BUSY = "FAILED_PORT_BUSY";
  public static final String FAILED_NO_PASSWDFILE = "FAILED_NO_PASSWDFILE";
  public static final String UNLIMITED = "UNLIMITED";
  public static final String UNDEFINED = "UNDEFINED";
    
}

