// $Id: AcceptThread.java,v 1.8 1999/04/07 20:37:26 beca Exp $
/*
File: AcceptThread.java
Component: Plugin
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;


import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.structures.Registrar;
import netscape.security.PrivilegeManager;
import webwisdom.tango.test.Log;


/**Demon thread handling connections from socket applications.*/
public class AcceptThread implements Runnable
{
    private static final String CL="AcceptThread";


    private ServerSocket s;
    private Thread th;
    private Registrar reg;
    private boolean noexit;


    public AcceptThread(ServerSocket spar,Registrar regpar)
    {
      s=spar;
      reg=regpar;
      noexit=true;
      th=new Thread(this, "AcceptThread:" + hashCode());
      th.setDaemon(true);
      th.start();
    }// AcceptThread _______________________________________________________


    public void run()
    {
      //System.out.println(CL+".run()");
      PrivilegeManager.enablePrivilege("30Capabilities");
      do
      {
	Socket conn;    
	try
	{
	  conn=s.accept();
	}
	catch(InterruptedIOException e)
	{
	  //System.out.println(CL+": repeating accept");
	  conn=null;
	  continue;
	}
	catch(IOException e)
	{
	  Log.err.println(CL+": accepting connections terminated: "+e, 2);
//	  e.printStackTrace(Log.err);
	  reg.errorAcc();
	  conn=null;
	}
	if(noexit)
	{
	  reg.handleConnection(conn);
	}
/*	else
	{ 
	  try
	  {
	    s.close();
	  }
	  catch(IOException e)
	  {
	    Log.out.println(CL+": "+e, 1);
	    e.printStackTrace(Log.err);
	  }
	} */
	
      }while(noexit);
      Log.out.println(CL+": exiting", 2);
    }// run ________________________________________________________________

 
    public void stop()
    {
      Log.out.println(CL+".stop() and now... ", 2);      
      noexit=false;
      
      Log.out.println(CL+": trying to close socket", 2);
      
      try {
	      s.close();
	    } catch (IOException e) {
	    
	      Log.out.println(CL + ": close failed", 2);
	      	    
	    }
	    
	    Log.out.println(CL+": socket closed");
	    
	    
    }// stop _______________________________________________________________


}// AcceptThread ///////////////////////////////////////////////////////////


