// $Id: ThreadOut.java,v 1.6 1999/03/30 18:48:39 beca Exp $
/*
File: ThreadOut.java
Component: Server, Plugin
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;


import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.messages.Net;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.MessageQueue;
import webwisdom.tango.test.Log;


/**Server thread.*/
public class ThreadOut implements Runnable
{
    private static final String CL="ThreadOut";


    private MessageQueue q;
    private Net n;
    private Thread th;
    private boolean exit;


    static int number = 1;    //for testing only
    int thisno;  //for testing only


    public ThreadOut(Socket s)
    {
      super();    

      thisno = number;
      number ++;

      n=new Net(s);
      q=new MessageQueue();
      th=new Thread(this, "ThreadOut:" + hashCode());
      exit=false;
      th.start();
    }// ThreadOut __________________________________________________________


    public void run()
    {
      //System.out.println(CL+"."+thisno+".run()");
      while(!exit)
      {
	Message m=q.getMessage();
	try
	{
	  n.send(m);
	}
	catch(IOException e)
	{
	  Log.err.println(CL+"."+thisno+": problems with sending!: "+e, 2);
	  e.printStackTrace(Log.err);
	}
      }
    }// run ________________________________________________________________


    public synchronized void putMessage(Message m)
    {
      q.putMessage(m);
    }// putMessage _________________________________________________________

 
    public synchronized void stop()
    {
      //System.out.println(CL+".stop()");
      System.out.flush();
      exit=true;
      q.unblock();
    }// stop _______________________________________________________________


}// ThreadOut //////////////////////////////////////////////////////////////

